// $Id: fb.js,v 1.5 2010/02/18 21:25:47 rhoney Exp $

Ext.ns('Drupal.take_Control_fb');
var fb = Drupal.take_Control_fb;

fb.settings = window.parent.Drupal.settings.take_control_fb;
Ext.BLANK_IMAGE_URL = fb.settings.extPath + '/resources/images/default/s.gif';
fb.rootFolder = fb.settings.appDir;
fb.curFolder = '';
fb.prevFolders = [];
fb.nextFolders = [];

Ext
		.onReady(function() {
			Ext.QuickTips.init();

			var fileStore = new Ext.data.JsonStore( {
				// store configs
				autoDestroy: true,
				// reader configs
				root: 'files',
				idProperty: 'id',
				fields: [ 'id', 'text', 'cls', 'modified', 'owner', 'perm', 'mime',
						'size' ],
				data: {
					files: []
				}
			});
			var fileSelModel = new Ext.grid.CheckboxSelectionModel( {
				checkOnly: true,
				listeners: {
					selectionChange: fb.filesSelectionChanged
				}
			});

			var p = new Ext.Panel(
					{
						title: 'File Browser',
						renderTo: 'take_control_fb_container',
						autoWidth: true,
						height: 500,
						layout: 'hbox',
						layoutConfig: {
							align: 'stretch'
						},
						tbar: {
							xtype: 'toolbar',
							items: [ {
								xtype: 'button',
								text: 'New Folder',
								iconCls: 'icon-folder_add',
								ref: '../btnNewFolder',
								listeners: {
									click: fb.btnNewFolderClicked
								}
							}, {
								xtype: 'button',
								text: 'New File',
								iconCls: 'icon-page_add',
								ref: '../btnNewFile',
								listeners: {
									click: fb.btnNewFileClicked
								}
							}, {
								xtype: 'button',
								text: 'Copy',
								iconCls: 'icon-page_copy',
								ref: '../btnCopy',
								disabled: true,
								hidden: true
							}, {
								xtype: 'button',
								text: 'Move',
								iconCls: 'icon-page_go',
								ref: '../btnMove',
								disabled: true,
								hidden: true
							}, {
								xtype: 'button',
								text: 'Upload',
								iconCls: 'icon-folder_up',
								ref: '../btnUpload',
								hidden: true
							}, {
								xtype: 'button',
								text: 'Download',
								iconCls: 'icon-package_down',
								ref: '../btnDownload',
								disabled: true,
								listeners: {
									click: fb.btnDownloadClicked
								}
							}, {
								xtype: 'button',
								text: 'Delete',
								iconCls: 'icon-delete',
								ref: '../btnDelete',
								disabled: true,
								hidden: true
							}, {
								xtype: 'tbseparator'
							}, {
								xtype: 'button',
								text: 'Rename',
								iconCls: 'icon-drive_rename',
								ref: '../btnRename',
								disabled: true,
								hidden: true
							}, {
								xtype: 'button',
								text: 'Edit',
								iconCls: 'icon-page_edit',
								ref: '../btnEdit',
								disabled: true,
								hidden: true
							}, {
								xtype: 'button',
								text: 'Code Editor',
								iconCls: 'icon-page_white_code',
								ref: '../btnEditCode',
								disabled: true,
								hidden: true
							}, {
								xtype: 'button',
								text: 'HTML Editor',
								iconCls: 'icon-html',
								ref: '../btnEditHtml',
								disabled: true,
								hidden: true
							}, {
								xtype: 'tbseparator'
							}, {
								xtype: 'button',
								text: 'Extract',
								iconCls: 'icon-arrow_out',
								ref: '../btnExtract',
								disabled: true,
								hidden: true
							}, {
								xtype: 'button',
								text: 'Compress',
								iconCls: 'icon-compress',
								ref: '../btnCompress',
								disabled: true,
								hidden: true
							} ]
						},
						bbar: {
							xtype: 'toolbar',
							items: [ {
								xtype: 'label',
								text: 'Current User Id: ' + fb.settings.curUserId
							} ]
						},
						items: [
								{
									xtype: 'treepanel',
									layout: 'fit',
									flex: 3,
									title: 'Folder Explorer',
									ref: 'folderPanel',
									dataUrl: fb.settings.dataUrl,
									autoScroll: true,
									useArrows: true,
									animate: true,
									containerScroll: true,
									requestMethod: 'POST',
									trackMouseOver: true,
									listeners: {
										'click': fb.foldersNodeClicked
									},
									rootVisible: true,
									root: {
										nodeType: 'async',
										id: fb.rootFolder,
										text: fb.rootFolder,
										draggable: false,
										expanded: true
									},
									loader: {
										url: fb.settings.dataUrl,
										baseParams: fb.getRequestParams('list-subdirs', {}),
										listeners: {
											loadException: function(loader, node, response) {
												Ext.Msg.alert('Action Failure', response.responseText);
											}
										// 'beforeload': function(loader, node, callback) {
										// var tree = node.ownerTree;
										// if (!tree.loadMask) {
										// tree.loadMask = new Ext.LoadMask(tree.getEl().dom, {
										// msg: 'Loading...'
										// });
										// }
										// tree.loadMask.show();
										// },
										// 'load': function(loader, node, response) {
										// node.ownerTree.loadMask.hide();
										// }
										}
									},
									tbar: {
										xtype: 'toolbar',
										items: [
												{
													xtype: 'tbtext',
													'text': 'Current: '
												},
												{
													xtype: 'textfield',
													width: 200,
													ref: '../txtCurrentDir'
												},
												{
													xtype: 'button',
													text: 'Go',
													listeners: {
														'click': function(el) {
															fb.nextFolders.splice(0, fb.nextFolders.length);
															fb.loadFiles(fb.folders.txtCurrentDir.getValue(),
																	true);
														}
													}
												} ]
									},
									tools: [
											{
												id: 'up',
												qtip: 'Collpase All',
												handler: function(event, toolEl, panel) {
													fb.folders.collapseAll();
												}
											},
											{
												id: 'down',
												qtip: 'Expand All',
												handler: function(event, toolEl, panel) {
													Ext.Msg
															.confirm(
																	'Action confirmation',
																	'Are you sure you want to expand all folders?<br /> This might take a lot of time depending upon the number of folders.',
																	function(btn) {
																		if (btn == 'yes') {
																			// This will also expand nodes as they
																			// arrive. So, better copy nodeHash, and
																			// then expand manually.
																			// fb.folders.expandAll();
																			var nodes = [];
																			for (key in fb.folders.nodeHash) {
																				nodes.push(fb.folders.nodeHash[key]);
																			}
																			for (i = 0; i < nodes.length; i++) {
																				nodes[i].expand();
																			}
																		}
																	});
												}
											},
											{
												id: 'gear',
												qtip: 'Recursive Expand All',
												handler: function(event, toolEl, panel) {
													Ext.Msg
															.confirm(
																	'Action confirmation',
																	'Are you sure you want to recursively expand all folders?<br /> This might take <b>excessively large time</b> depending upon the number of folders.',
																	function(btn) {
																		if (btn == 'yes') {
																			fb.folders.expandAll();
																		}
																	});
												}
											}, {
												id: 'refresh',
												qtip: 'Refresh',
												handler: function(event, toolEl, panel) {
													var root = fb.folders.getRootNode();
													fb.folders.loader.load(root, function(node) {
														node.expand();
													});
												}
											} ]
								},
								{
									xtype: 'grid',
									flex: 7,
									title: 'File Explorer',
									ref: 'filePanel',
									store: fileStore,
									autoExpandColumn: 'name',
									stripeRows: true,
									listeners: {
										'cellclick': fb.filesCellClick,
										'rowdblclick': fb.filesRowDblClick
									},
									sm: fileSelModel,
									cm: new Ext.grid.ColumnModel(
											[
													new Ext.grid.RowNumberer(),
													fileSelModel,
													{
														header: '',
														sortable: false,
														dataIndex: 'cls',
														width: 30,
														renderer: function(value, metaData, record,
																rowIndex, colIndex, store) {
															var img = '<img src="{0}" class="{1}" title="{2}" width="16" height="16" />'
															img = String.format(img, Ext.BLANK_IMAGE_URL,
																	value == 'folder' ? 'icon-folder'
																			: 'icon-page_white', value);
															return (img);
														}
													}, {
														header: 'Name',
														sortable: true,
														dataIndex: 'text',
														id: 'name'
													}, {
														header: 'Size',
														sortable: true,
														dataIndex: 'size',
														width: 50
													}, {
														header: 'Type',
														sortable: true,
														dataIndex: 'mime',
														width: 150
													}, {
														header: 'Owner',
														sortable: true,
														dataIndex: 'owner',
														width: 30
													}, {
														header: 'Perms',
														sortable: true,
														dataIndex: 'perm',
														width: 50
													}, {
														header: 'Last Modified',
														sortable: true,
														dataIndex: 'modified',
														width: 150
													} ]),
									tbar: {
										xtype: 'toolbar',
										items: [ {
											xtype: 'button',
											text: 'Home',
											iconCls: 'icon-application_home',
											ref: '../btnHome',
											disabled: true,
											listeners: {
												'click': fb.btnHomeClicked
											}
										}, {
											xtype: 'button',
											text: 'Up One Level',
											iconCls: 'icon-arrow_up',
											ref: '../btnFolderUp',
											disabled: true,
											listeners: {
												'click': fb.btnFolderUpClicked
											}
										}, {
											xtype: 'button',
											text: 'Back',
											iconCls: 'icon-arrow_left',
											ref: '../btnFolderPrev',
											disabled: true,
											listeners: {
												'click': fb.btnFolderPrevClicked
											}
										}, {
											xtype: 'button',
											text: 'Forward',
											iconCls: 'icon-arrow_right',
											ref: '../btnFolderNext',
											disabled: true,
											listeners: {
												'click': fb.btnFolderNextClicked
											}
										}, {
											xtype: 'button',
											text: 'Reload',
											iconCls: 'icon-arrow_refresh',
											ref: '../btnFilesRefresh',
											listeners: {
												'click': fb.btnFilesRefreshClicked
											}
										}, {
											xtype: 'tbseparator'
										}, {
											xtype: 'button',
											text: 'Change Permissions',
											iconCls: 'icon-key',
											ref: '../btnPerm',
											disabled: true
										}, {
											xtype: 'button',
											text: 'View',
											iconCls: 'icon-zoom',
											ref: '../btnView',
											disabled: true,
											listeners: {
												click: fb.btnViewClicked
											}
										} ]
									}
								} ]
					});

			fb.parent = p;
			fb.folders = p.folderPanel;
			fb.files = p.filePanel;

			new Ext.tree.TreeSorter(fb.folders, {
				folderSort: true
			});

			// Load root directory nodes.
			fb.loadFiles(fb.rootFolder, false);

			fb.viewWindow = new Ext.Window( {
				width: 500,
				height: 400,
				layout: 'fit',
				closeAction: 'hide',
				modal: true,
				items: [ {
					xtype: 'textarea',
					ref: 'txtView'
				} ]
			});

		});

// /////////////////////////////////////////////////////////////////////////////

fb.getRequestParams = function(op, params) {
	params.op = op;
	params.secToken = fb.settings.secToken;
	params.loginTime = fb.settings.loginTime;

	return (params);
}

fb.createUrl = function(params) {
	var str = '';
	for (key in params) {
		str = str + key + '=' + encodeURIComponent(params[key]) + '&';
	}
	str = fb.settings.dataUrl + '?' + str.substring(0, str.length - 1);

	return (str);
}

fb.reloadFolder = function(dir) {
	var node = fb.folders.getNodeById(dir);
	var expanded = node.isExpanded();
	if (!Ext.isEmpty(node)) {
		fb.folders.loader.load(node, function(node) {
			if (expanded) {
				node.expand();
			}
		});
	}
}

fb.loadFiles = function(dir, addToPrev) {
	if (dir.indexOf(fb.rootFolder) != 0) {
		if (dir.charAt(0) != '/')
			dir = '/' + dir;
		dir = fb.rootFolder + dir;
	}

	if (!fb.files.loadMask) {
		fb.files.loadMask = new Ext.LoadMask(fb.files.getEl().dom, {
			msg: 'Loading...'
		});
	}
	fb.files.loadMask.show();

	Ext.Ajax.request( {
		url: fb.settings.dataUrl,
		params: fb.getRequestParams('list-files', {
			node: dir
		}),
		method: 'POST',
		success: function(response, options) {
			fb.files.loadMask.hide();

			var json = response.responseText;
			if (json.charAt(0) != '[' && json.charAt(0) != '{') {
				Ext.Msg.alert('Action Failure', json);
				return;
			}

			var files = Ext.decode(json);
			fb.files.store.loadData( {
				files: files
			}, false);

			if (addToPrev && !Ext.isEmpty(fb.curFolder)) {
				fb.prevFolders.push(fb.curFolder);
			}
			fb.curFolder = dir;
			fb.files.btnFolderPrev.setDisabled(fb.prevFolders.length == 0);
			fb.files.btnFolderNext.setDisabled(fb.nextFolders.length == 0);
			fb.files.btnHome.setDisabled(fb.rootFolder == fb.curFolder);
			fb.files.btnFolderUp.setDisabled(fb.rootFolder == fb.curFolder);
			fb.folders.txtCurrentDir.setValue(dir);
		}
	});
}

// /////////////////////////////////////////////////////////////////////////////
// Toolbar/File Load button click handlers.

fb.foldersNodeClicked = function(node, e) {
	node.expand();
	fb.nextFolders.splice(0, fb.nextFolders.length);
	fb.loadFiles(node.id, true);
}

fb.btnHomeClicked = function(el) {
	fb.nextFolders.splice(0, fb.nextFolders.length);
	var dir = fb.rootFolder;
	fb.loadFiles(dir, true);
}

fb.btnFolderUpClicked = function(el) {
	var index = fb.curFolder.lastIndexOf('/');
	if (index == -1)
		index = fb.curFolder.lastIndexOf('\\');
	if (index == -1) {
		Ext.Msg.alert('Action Failure', 'Invalid Root directory');
		return;
	}
	var dir = fb.curFolder.substring(0, index);
	fb.loadFiles(dir, true);
}

fb.btnFolderPrevClicked = function(el) {
	fb.nextFolders.push(fb.curFolder);
	var dir = fb.prevFolders.pop();
	fb.loadFiles(dir, false);
}

fb.btnFolderNextClicked = function(el) {
	var dir = fb.nextFolders.pop();
	fb.loadFiles(dir, true);
}

fb.btnFilesRefreshClicked = function(el) {
	fb.loadFiles(fb.curFolder, false);
}

// /////////////////////////////////////////////////////////////////////////////
// Button enable/disable handlers.

fb.filesCellClick = function(grd, rowIndex, colIndex, e) {
	if (colIndex != 1) {
		if (grd.selModel.isSelected(rowIndex)) {
			grd.selModel.deselectRow(rowIndex);
		} else {
			grd.selModel.selectRow(rowIndex, true);
		}
	}
}

fb.filesRowDblClick = function(grd, rowIndex, e) {
	var rec = grd.store.data.items[rowIndex];
	if (rec.data.cls == 'folder') {
		fb.loadFiles(rec.data.id, true);
	}
}

fb.filesSelectionChanged = function(sm) {
	var noSel = !sm.hasSelection();
	var single = sm.getCount() == 1;
	var isFile = false;
	if (single) {
		var rec = sm.getSelected();
		isFile = rec.data.cls == 'file';
	}

	fb.parent.btnDownload.setDisabled(!single || !isFile);
	fb.parent.btnCopy.setDisabled(noSel);
	fb.parent.btnMove.setDisabled(noSel);
	fb.parent.btnDelete.setDisabled(noSel);

	fb.parent.btnRename.setDisabled(!single);
	fb.parent.btnEdit.setDisabled(!single || !isFile);
	fb.parent.btnEditCode.setDisabled(!single || !isFile);
	fb.parent.btnEditHtml.setDisabled(!single || !isFile);

	fb.parent.btnCompress.setDisabled(noSel);

	fb.files.btnPerm.setDisabled(noSel);
	fb.files.btnView.setDisabled(!single || !isFile);
}

// /////////////////////////////////////////////////////////////////////////////
// Toolbar button logic.

fb.btnNewFolderClicked = function(el) {
	var parent = fb.curFolder;
	Ext.Msg
			.prompt(
					'Create New folder',
					'Enter folder name. Folder would be created in <br /><b>' + fb.curFolder + '</b>',
					function(btn, value) {
						if (btn != 'ok' || Ext.isEmpty(value))
							return;
						fb.files.loadMask.show();

						Ext.Ajax.request( {
							url: fb.settings.dataUrl,
							params: fb.getRequestParams('create-folder', {
								parent: parent,
								name: value
							}),
							method: 'POST',
							success: function(response, options) {
								fb.files.loadMask.hide();

								var response = response.responseText;
								if (!Ext.isEmpty(response)) {
									Ext.Msg.alert('Action Failure', response);
									return;
								}

								fb.loadFiles(parent, false);
								fb.reloadFolder(parent);
							}
						});
					});
}

fb.btnNewFileClicked = function(el) {
	var parent = fb.curFolder;
	Ext.Msg
			.prompt(
					'Create New file',
					'Enter file name. File would be created in <br /><b>' + fb.curFolder + '</b>',
					function(btn, value) {
						if (btn != 'ok' || Ext.isEmpty(value))
							return;
						fb.files.loadMask.show();

						Ext.Ajax.request( {
							url: fb.settings.dataUrl,
							params: fb.getRequestParams('create-file', {
								parent: parent,
								name: value
							}),
							method: 'POST',
							success: function(response, options) {
								fb.files.loadMask.hide();

								var response = response.responseText;
								if (!Ext.isEmpty(response)) {
									Ext.Msg.alert('Action Failure', response);
									return;
								}

								fb.loadFiles(parent, false);
							}
						});
					});
}

fb.btnDownloadClicked = function(el) {
	try {
		Ext.destroy(Ext.get('take_control_fb_container_download_frame'));
	} catch (e) {
	}

	var rec = fb.files.selModel.getSelected();
	var params = fb.getRequestParams('download-file', {
		file: rec.data.id,
		op: 'download-file'
	});

	var url = fb.createUrl(params);

	Ext.DomHelper.append(document.body, {
		tag: 'iframe',
		id: 'take_control_fb_container_download_frame',
		frameBorder: 0,
		width: 0,
		height: 0,
		css: 'display:none;visibility:hidden;height:0px;',
		src: url
	});
}

fb.btnViewClicked = function(el) {
	var rec = fb.files.selModel.getSelected();
	fb.files.loadMask.show();

	Ext.Ajax.request( {
		url: fb.settings.dataUrl,
		params: fb.getRequestParams('view-file', {
			file: rec.data.id
		}),
		method: 'POST',
		success: function(response, options) {
			fb.files.loadMask.hide();

			fb.viewWindow.txtView.setValue(response.responseText);
			fb.viewWindow.show();
			fb.viewWindow.center();
			fb.viewWindow.setTitle(rec.data.id);
		}
	});
}
