<?php
// $Id: filesystem.inc,v 1.5 2010/02/18 21:25:46 rhoney Exp $


require_once ('security.inc');

/**
 * Should be used only from scripts running under Drupal bootstrap, where Drupal's index.php is the central script
 * executing for the server.
 */
function take_control_app_dir() {
  return (dirname($_SERVER['SCRIPT_FILENAME']));
}

function take_control_app_url() {
  return ($_SERVER['SERVER_NAME'] . base_path());
}

function take_control_client_path($path) {
  return (base_path() . $path);
}

function take_control_base_extjs_dir() {
  return (take_control_app_dir() . str_replace('/', DIRECTORY_SEPARATOR, '/sites/all/libraries/extjs'));
}

function take_control_config_dir() {
  $curdir = dirname(__FILE__);
  $pubkeydir = realpath($curdir . '/..') . DIRECTORY_SEPARATOR . 'temp';
  return ($pubkeydir);
}

function take_control_config_file() {
  return (take_control_config_dir() . DIRECTORY_SEPARATOR . 'tc.ini');
}

function take_control_save_config_items($items, $flush = FALSE) {
  $pubkeydir = take_control_config_dir();

  if (!is_dir($pubkeydir)) {
    $success = mkdir($pubkeydir, 0775);
    if (!$success) {
      return (FALSE);
    }
  }
  $file = take_control_config_file();

  $config = NULL;
  if ($flush || !file_exists($file)) {
    $config = $items;
  }
  else {
    $config = parse_ini_file($file);
    foreach ($items as $key => $value) {
      $config[$key] = $value;
    }
  }

  $content = '';
  foreach ($config as $key => $value) {
    if (strpos($value, "\r") !== FALSE || strpos($value, "\n") !== FALSE) {
      $value = '"' . $value . '"';
    }
    $content = $content . $key . '=' . $value . "\r\n";
  }
  $success = file_put_contents($file, $content);
  if ($success === FALSE) {
    return (FALSE);
  }
  else {
    chmod($file, 0600);
    file_put_contents($pubkeydir . DIRECTORY_SEPARATOR . '.htaccess', "Order deny, allow\n");

    return (TRUE);
  }
}

function take_control_delete_directory($dir) {
  if (!file_exists($dir))
    return true;
  if (!is_dir($dir))
    return unlink($dir);
  foreach (scandir($dir) as $item) {
    if ($item == '.' || $item == '..')
      continue;
    if (!take_control_delete_directory($dir . DIRECTORY_SEPARATOR . $item))
      return false;
  }
  return rmdir($dir);
}
